octolib.registerAnimationCategory('simple', {
	name = 'Жесты и действия',
	order = 1,
	type = 'act',
	anims = {
		{ 'Одобрить', ACT_GMOD_GESTURE_AGREE },
		{ 'Подозвать', ACT_GMOD_GESTURE_BECON },
		{ 'Поклониться', ACT_GMOD_GESTURE_BOW },
		{ 'Пригрозить пальцем', ACT_GMOD_GESTURE_DISAGREE },
		{ 'Воинское приветствие', ACT_GMOD_TAUNT_SALUTE },
		{ 'Помахать рукой', ACT_GMOD_GESTURE_WAVE },
		{ 'Сигнал: вперед', ACT_SIGNAL_FORWARD },
		{ 'Сигнал: группировка', ACT_SIGNAL_GROUP },
		{ 'Сигнал: стоп', ACT_SIGNAL_HALT },
		{ 'Замахнуться рукой', ACT_HL2MP_GESTURE_RANGE_ATTACK_FIST },
		{ 'Махнуть перед собой', ACT_GMOD_GESTURE_MELEE_SHOVE_1HAND },
		{ 'Положить предмет', ACT_GMOD_GESTURE_ITEM_PLACE },
		{ 'Дать предмет', ACT_GMOD_GESTURE_ITEM_GIVE },
		{ 'Выбросить предмет', ACT_GMOD_GESTURE_ITEM_DROP },
		{ 'Кинуть предмет', ACT_GMOD_GESTURE_ITEM_THROW },
	},
})

octolib.registerAnimationCategory('freezed', {
	name = 'Анимации на месте',
	order = 2,
	type = 'act',
	freeze = true,
	donate = true,
	anims = {
		{ 'Насмехаться', ACT_GMOD_TAUNT_LAUGH },
		{ 'Радоваться', ACT_GMOD_TAUNT_CHEER },
		{ 'Устрашить', ACT_GMOD_TAUNT_PERSISTENCE },
		{ 'Танцевать', ACT_GMOD_TAUNT_DANCE },
		{ 'Роботанец', ACT_GMOD_TAUNT_ROBOT },
		{ 'Горячий танец', ACT_GMOD_TAUNT_MUSCLE },
	},
})

octolib.registerAnimationCategory('stand', {
	name = 'Стойка',
	order = 3,
	type = 'seq',
	stand = true,
	anims = {
		{ 'Руки вверх', 'idle_all_01', bones = {
			['ValveBiped.Bip01_R_UpperArm'] = Angle(30, 0, 90),
			['ValveBiped.Bip01_L_UpperArm'] = Angle(-30, 0, -90),
			['ValveBiped.Bip01_R_ForeArm'] = Angle(0, -130, 0),
			['ValveBiped.Bip01_L_ForeArm'] = Angle(0, -120, 20),
		}},
		{ 'Руки за голову', 'idle_all_01', bones = {
			['ValveBiped.Bip01_R_UpperArm'] = Angle(110, -15, 90),
			['ValveBiped.Bip01_L_UpperArm'] = Angle(-115, 10, -110),
			['ValveBiped.Bip01_R_ForeArm'] = Angle(-5, -120, 0),
			['ValveBiped.Bip01_L_ForeArm'] = Angle(2, -120, 20),
			['ValveBiped.Bip01_Head1'] = Angle(0, -20, 0),
		}},
		{ 'Показать пальцем', 'idle_all_01', bones = {
			['ValveBiped.Bip01_R_UpperArm'] = Angle( 22, -70, 0),
			['ValveBiped.Bip01_R_Hand'] = Angle( -20, -5, 0),
			['ValveBiped.Bip01_R_Finger0'] = Angle( 0, 10, 0),
			['ValveBiped.Bip01_R_Finger1'] = Angle( 0, 20, 0),
			['ValveBiped.Bip01_R_Finger2'] = Angle( 0, -50, 0),
			['ValveBiped.Bip01_R_Finger22'] = Angle( 0, -90, 0),
			['ValveBiped.Bip01_R_Finger21'] = Angle( 0, -90, 0),
			['ValveBiped.Bip01_R_Finger3'] = Angle( -10, -50, 0),
			['ValveBiped.Bip01_R_Finger31'] = Angle( -10, -50, 0),
			['ValveBiped.Bip01_R_Finger32'] = Angle( -10, -50, 0),
			['ValveBiped.Bip01_R_Finger4'] = Angle( -20, -50, 0),
			['ValveBiped.Bip01_R_Finger41'] = Angle( 0, -50, 0),
			['ValveBiped.Bip01_R_Finger42'] = Angle( 0, -50, 0),
			['ValveBiped.Bip01_R_ForeArm'] = Angle( -10, -25, -90),
		}},
		{ 'Остановить', 'idle_all_01', bones = {
			['ValveBiped.Bip01_R_UpperArm'] = Angle( 25, -45, 0),
			['ValveBiped.Bip01_R_Hand'] = Angle( -20, 65, 0),
			['ValveBiped.Bip01_R_ForeArm'] = Angle( -10, -50, -90),
		}},
		{ 'Скрестить руки', 'pose_standing_01' },
		{ 'Руки на пояс', 'pose_standing_02' },
		{ 'Представить вниманию', 'pose_standing_03' },
		{ 'Двойной палец вверх', 'pose_standing_04' },
		{ 'Преклониться', 'pose_ducking_01' },
		{ 'Поза лотоса', 'pose_ducking_02' },
		{ 'Стоять настороженно', 'menu_combine' },
		{ 'Стоять смирно', 'menu_gman', startTime = 1 },
		{ 'Угрожать замахнувшись', 'idle_melee_angry' },
		{ 'Стоять вразвалку', 'idle_suitcase' },
		{ 'Плохое самочувствие', 'menu_zombie_01', startTime = 1 },
	},
})

octolib.registerAnimationCategory('walk', {
	name = 'Походка',
	order = 4,
	type = 'seq',
	anims = {
		{ 'Идти нормально', '' },
		-- { 'Развалистая походка', 'walk_suitcase' },
		{ 'Прикрываться одной рукой', 'run_all_panicked_01' },
		{ 'Прикрываться двумя руками', 'run_all_panicked_02' },
		{ 'Прикрывать голову руками', 'run_all_panicked_03' },
		{ 'Бежать прикрываясь напролом', 'run_all_protected' },
		{ 'Бежать напролом', 'run_all_charging' },
		{ 'Бежать быстро', 'run_all_02' },
	},
})